/////////////////////////////////////////////////////////////////
//Feigenbaum- und Lyapunov-Diagramm
//////////////////////////////////////////////////////////////

//Initialisierung:
float rU = 0; //untere Grenze von r
float rO = 0; //obere Grenze von r
float fU = 0; //Wertebereich Feigenbaum
float fO = 0;
float lU = 0;//Wertebereich Lyapunov
float lO = 0;
//Zwischenspeicher. Neuer Wertebereich für
float  rUNeu, rONeu; //r
float fUNeu, fONeu; //f (Feigenbaum)
float lUNeu, lONeu; //l  (Lyapunov)
float lAlt, fAlt, fNeu, d; 
int w = 600; 
int h = 600; 
int NF, LF;
int i; //Iteration Feigenbaum
float flK; // r-Koordinate für beide
float fyK; //y-Koordinaten Feigenbaum
float NullAchseF;

float r; //Parameter für logistisches Wachstum

float sL; //Lyap Summe
float lambda; //LypExp
int NL, LL;
float lNeu;
float lyK; //Koordinaten Lyapunov
float NullAchseL;
float f; //Anzahl der Schritte in Lyapanov im Vergleich zu Feigenbaum

///////////////////////////////////////////////////////////////////////////


//Initialisierungen  
void setup() { 
  size(600,600);
  background(255); 
  rU =2.8; 
  rO = 3.9;
  fU = -0.05; 
  fO = 1;
  lU = -5;
  lO =1.2;
  NF= 800; //Anzahl Iterationen Feigenbaum
  LF =500; //Feigenbaum ab hier gerechnet
  r = rU; //Start r
  d = (rO-rU)/2000; //Schrittweite
 
  NL = 800; //Anzahl Iterationen Lyapunov
  LL = 100 ; //Lyapunov ab hier gerechnet
  f=256;//Anzahl der Schritte für Laypunov bei einem Schritt Feigenbaum
  
}

void draw() {
  if (r<rO) r = r+d;
  for(int i =0; i<f; i++){
     iteriereL(r);
      r =r + d/f;
  }
  iteriereF(r);
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(255);

  rUNeu = map(mouseX, 0, w, rU, rO)-(rO-rU)/10;
  rONeu = map(mouseX, 0, w, rU, rO)+(rO-rU)/10;
  fUNeu = map(mouseY, 0, h, fO, fU)-(fO-fU)/10;
  fONeu = map(mouseY, 0, h, fO, fU)+(fO-fU)/10;
  lUNeu = map(mouseY, 0, h, lO, lU)-(lO-lU)/10; 
  lONeu = map(mouseY, 0, h, lO, lU)+(lO-lU)/10; 
  rU = rUNeu; 
  rO = rONeu; 
  fU = fUNeu; 
  fO = fONeu;
  lU = lUNeu;
  lO = lONeu;
  r = rU; 
  d = (rO-rU)/1000;
  NF = int(NF/(fO-fU));
  LF = int(LF/(lO-lU));
  println("mousePressed startet");
}
//////////////////////////////////////////////////////////
//Feigenbaum-Iteration
////////////////////////////////////////////////////////
void iteriereF(float r) {  
  stroke(0);
   strokeWeight(1);
  fAlt = 0.5; 
  flK = map(r, rU, rO, 0, w);      
  i=0;
  while (i <=NF) {
    fNeu = r*fAlt*(1-fAlt);
    if (i > LF && abs(fNeu) < 10) {
      fyK = map(fNeu, fU, fO, h, 0);   
      point(flK, fyK);    
    }
    fAlt = fNeu;
    i++;
  }
  stroke(0);
  strokeWeight(1.2);
  NullAchseF = map(0,fU,fO,h,0);
  point(flK, NullAchseF );
}

////////////////////////////////////////////////////////
//Lyapunov-Iteration
//////////////////////////////////////////////////////
void iteriereL(float r) {
  stroke(255,0,0);
  strokeWeight(1.2);
  lambda = 0;
  lAlt = 0.5;
  sL = 0;
  flK = map(r, rU, rO, 0, w);  
  i=0;
  while (i <=NL) {
    lNeu = r*lAlt*(1-lAlt);
    if (i > LL) {
       lNeu = r*lAlt*(1-lAlt);
       lAlt = lNeu;
       if(abs(r-2*r*lAlt) > 0)
       sL = sL + log(abs(r-2*r*lAlt));
    }
    lAlt = lNeu;
    i++;
  }
  lambda = sL/(NL-LL); 
  if(abs(lambda) < 10){
    lyK = map(lambda,lU,lO,h,0);
    point(flK, lyK);
  }
  stroke(0,0,255);
  strokeWeight(1.2);
  NullAchseL = map(0,lU,lO,h,0);
  point(flK, NullAchseL );
  
  
}